

/**** Fichiers d'inclusion ****/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <libwebsockets.h>
#include <string.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <linux/if.h>
#include <linux/if_tun.h>
#include <sys/types.h>

/**** constantes ****/
#define TAP_PRINCIPAL   "/dev/net/tun"
/**** globale ****/
char trame[350]={0};
char recu[350]={0};
unsigned char buffer[]={0};

/**** fonction serveur ****/
static int callback_http(struct lws *wsi,
                         enum lws_callback_reasons reason, void *user,
                         void *in, size_t len)
{


	return 0;
}



static int callback_my(struct lws *wsi,
                                   enum lws_callback_reasons reason,
                                   void *user, void *in, size_t len)
{
    switch (reason) {
        case LWS_CALLBACK_ESTABLISHED: 
            //printf("connection etablie\n");
            lws_callback_on_writable(wsi);
            break;

        case LWS_CALLBACK_RECEIVE: {
          //recuperation des donnees envoyees par le simulateur
			for (int i=0; i < len; i++) {
                recu[i] = ((char *) in)[i];
            }

            printf("trame recue :\n %s \n",recu);
            break;    
            }

        case LWS_CALLBACK_SERVER_WRITEABLE: {

            //envoie du paquet ICMP recu par le PING
            lws_write(wsi,&trame[LWS_SEND_BUFFER_PRE_PADDING],267,LWS_WRITE_TEXT);
            break;
        }
        default:
            break;
    }
    
    return 0;
}



static struct lws_protocols protocols[] = {
    {"http-only",callback_http,0},
    {"my",callback_my,0},
    {NULL, NULL, 0}
};

/*interface virtuelle*/
int creationInterfaceVirtuelle(char *nom)
{
struct ifreq interface;
int fd,erreur;

/* Ouverture du peripherique principal */
if((fd=open(TAP_PRINCIPAL,O_RDWR|O_NONBLOCK))<0)
    { 
        printf("error open");
        return fd;
    }

/* Preparation de la structure */
memset(&interface,0,sizeof(interface));
interface.ifr_flags=IFF_TAP|IFF_NO_PI;
if(nom!=NULL) strncpy(interface.ifr_name,nom,IFNAMSIZ);

/* Creation de l'interface */
if((erreur=ioctl(fd,TUNSETIFF,(void *)&interface))<0){ close(fd); return erreur; }
/* Recuperation du nom de l'interface */
strcpy(nom,interface.ifr_name);

return fd;
}


int main(void) {
    int port = 9500;
    int fd;
    char temp[350]={0};

    char *a_name = malloc(IFNAMSIZ);
    strcpy(a_name,"tap0");
    fd=creationInterfaceVirtuelle(a_name);

   struct lws_context *context;
    struct lws_context_creation_info context_info =
    {
        .port = port, .iface = NULL, .protocols = protocols, .extensions = NULL,
        .ssl_cert_filepath = NULL, .ssl_private_key_filepath = NULL, .ssl_ca_filepath = NULL,
        .gid = -1, .uid = -1, .options = 0, NULL, .ka_time = 0, .ka_probes = 0, .ka_interval = 0
    };
    // create lws context representing this server
    context = lws_create_context(&context_info);
        if (context == NULL) {
        fprintf(stderr, "lws init failed\n");
        return -1;
        }

    printf("starting server...\n");
  
    while (1)
    {
        
        lws_service(context, 50);

///////////////////envoi des donnees recues du simulateur vers l'interface virtuelle.///////////////////

            if(write(fd,recu,sizeof(recu))>=0)
            {//printf("message envoye\n");
    }
        

/////////////lecture des donnee et construction d'une trame de type String en hexadecimal//////////////////
        if(read(fd,buffer,84)>=0)
            {
            printf("Read bytes from device %s ", a_name);   
            for(int i=0;i<84;i++)
                {
                sprintf(&temp[i*4],"%d",buffer[i]);
                sprintf(&temp[(i*4)+3]," ");
                if(temp[(i*4)+1]>5 && temp[(i*4)]>0){
                sprintf(&trame[(LWS_SEND_BUFFER_PRE_PADDING)+i*3],"%x",buffer[i]);
                }
                else{
                sprintf(&trame[(LWS_SEND_BUFFER_PRE_PADDING)+(i*3)+1],"%x",buffer[i]);
                }
                trame[(LWS_SEND_BUFFER_PRE_PADDING)+(i*3)+2]=' ';
                
                if(trame[(LWS_SEND_BUFFER_PRE_PADDING)+(i*3)]<'0'){
                    trame[(LWS_SEND_BUFFER_PRE_PADDING)+(i*3)]='0';
                    }
                if(trame[(LWS_SEND_BUFFER_PRE_PADDING)+(i*3)+1]<'0'){
                    trame[(LWS_SEND_BUFFER_PRE_PADDING)+(i*3)+1]='0';
                    }
                }
            printf(" \n");

           for(int i=0;i<267;i++)
                {
                printf("%c",trame[i]);
                }
            printf(" \n");
        }
           
    }
    lws_context_destroy(context);

    return 0;
}
